;|
Dominique VAQUAND
14.12.2022
================================
Export des coordonnes des ports
================================
|;


(defun c:AP3D_CoordonneesPorts (/	Selection  CalqueCourant Fichier NomFichier
		     	Osmode	OBJ	   OBJ_1      OBJ_2
		     	X_LignesAxes	   PT_10      Index_S
		     	Index	PT_S1	   PT_S2      PT_S3
		    )


  (vl-load-com)
  
  ; Gestiion Erreur
      
      (defun *error* (s)
	(close Fichier)
	(setq *error* nil)
      )

; Slection des objets PLANT 3D
  (setq Selection (ssget (list (cons 0 "ACPPP*,ACPPC*"))))


  (setq Index_S 0)

; Si des objets sont slectionns
  
  (if Selection

    (progn

; Cration du fichier

      (setq NomFichier (getfiled "Extraction ports" "" "txt" 1))

      	(setq Fichier (open NomFichier "W"))

; Boucle sur le nombre d'objet PLANT 3D slectionns

      (repeat (sslength Selection)

	; rcupration des codes DXF primaires et VLA

	(setq OBJ (entget (ssname Selection Index_S)))
	(setq VLA_OBJ (vlax-ename->vla-object (ssname Selection Index_S)))

	; Mmorisation de la coordonne dpart ou point d'insertion
	(setq PT_10 (cdr (assoc 10 (reverse OBJ))))

	; Mmorisatiobn des pointeurs
	(setq OBJ_1 (entget (cdr (assoc 330 OBJ))))

	; traitement pour trouver les coordonnes des ports

	(TraitePortsObj obj_1 360 obj PT_10 VLA_OBJ)

	(setq index_S (1+ index_S))

      )	;repeat
    )
  ) ;if



; Fermeture du fichier

  (close Fichier)
  
(if (findfile NomFichier)
  (startapp "NotePad" NomFichier)
  )
  

  (princ)
)

;|
====================
Traitement des ports
====================
|;

(defun TraitePortsObj (Obj1x	   Codedxf  objx     PT_10x  VLA_OBJx /	       PT_S1A
		  PT_S2A	   PT_S3A    PT_S4A    PT_S5A    PT_S6A    index
		  OBJ_2
		 )


  ;; Tyuyau = (0 . "ACPPPIPE")
  ;; PT_10 et PT_11 existe

  ;; Composants = (0 . "ACPPPIPEINLINEASSET") ou (0 . "ACPPCONNECTOR")

  (setq index 0)
  (setq	PT_S1 nil
	PT_S2 nil
	PT_S3 nil
	PT_S4 nil
	PT_S5 nil
	PT_S6 nil
  )

  ; si l'objet PLANT 3D est un tuyau on rcupre les coordonnes des ports S1 et S2
  ; directement depuis la liste des cls primaires

  (if (= (cdr (assoc 0 objx)) "ACPPPIPE")
    (progn
      (setq pt_s1 (cdr (assoc 10 (reverse objx)))
	    pt_s2 (cdr (assoc 11 (reverse objx)))
      )
      
        (princ (strcat "\nComposant : " (vlax-get-property VLA_OBJx "PartFamilyLongDesc") " \ DN= " (vlax-get-property VLA_OBJx "Size") " \ Handle= " (vlax-get-property VLA_OBJx "Handle") "\n") Fichier)
       (princ (strcat "Num ligne= " (vlax-get-property VLA_OBJx "LineNumberTag") " Etiquette= " (vlax-get-property VLA_OBJx "Tag") "\n") Fichier)
      (princ (strcat "S1=" (rtos (car pt_s1))","(rtos (cadr pt_s1))","(rtos (caddr pt_s1)) "\nS2=" (rtos (car pt_s2))","(rtos (cadr pt_s2))","(rtos (caddr pt_s2))"\n") Fichier)

    )
    )
  
 (if (= (cdr (assoc 0 objx)) "ACPPPIPEINLINEASSET")

  ; Sinon on recherche les ports S1, S2, ... depuis un nouveau pointeur
  ; une fois les ports S1, S2, ... trouvs on rcupre les coordonnes du port  
    (progn

      (setq OBJ_2 (entget (cdr (assoc Codedxf OBJ1x))))

  ; on boucle sur la liste pour rcuprer les coordonnes du port    

(setq Ports "")
      
      (repeat (length OBJ_2)



	(if (= (cdr (nth index OBJ_2)) "S1")
	  (if (= PT_S1 nil)
	    (progn
	    (setq PT_S1 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S1=" (rtos (car pt_s1))","(rtos (cadr pt_s1))","(rtos (caddr pt_s1))"\n"))
	    )
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S2")
	  (if (= PT_S2 nil)
	    (progn
	    (setq PT_S2 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S2=" (rtos (car pt_s2))","(rtos (cadr pt_s2))","(rtos (caddr pt_s2))"\n"))
	    )
	  
	)
	  )

	(if (= (cdr (nth index OBJ_2)) "S3")
	  (if (= PT_S3 nil)
	    (progn
	    (setq PT_S3 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S3=" (rtos (car pt_s3))","(rtos (cadr pt_s3))","(rtos (caddr pt_s3))"\n"))
	    )
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S4")
	  (if (= PT_S4 nil)
	    (progn
	    (setq PT_S4 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S4=" (rtos (car pt_s4))","(rtos (cadr pt_s4))","(rtos (caddr pt_s4))"\n"))
	    )
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S5")
	  (if (= PT_S5 nil)
	    (progn
	    (setq PT_S5 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S5=" (rtos (car pt_s5))","(rtos (cadr pt_s5))","(rtos (caddr pt_s5))"\n"))
	    )
	  )
	)

	(if (= (cdr (nth index OBJ_2)) "S6")
	  (if (= PT_S6 nil)
	    (progn
	    (setq PT_S6 (cdr (nth (1+ index) OBJ_2)))
	    (setq Ports (strcat Ports "S6=" (rtos (car pt_s6))","(rtos (cadr pt_s6))","(rtos (caddr pt_s6))"\n"))
	    )
	  )
	)

	
	
	(setq index (1+ index))

      )	;repeat

      ;on crit les coordonnes des ports
	(princ (strcat "\nComposant : " (vlax-get-property VLA_OBJx "PartFamilyLongDesc") " \ DN= " (vlax-get-property VLA_OBJx "Size") " \ Handle= " (vlax-get-property VLA_OBJx "Handle") "\n") Fichier)
(princ (strcat "Num ligne= " (vlax-get-property VLA_OBJx "LineNumberTag") " Etiquette= " (vlax-get-property VLA_OBJx "Tag") "\n") Fichier)
      (princ Ports Fichier)
     
      
    )
  ) ;if

(princ)


) ;defun

